From - Fri Dec  3 11:14:52 1999
Received: from audix (audix.npac.syr.edu [128.230.21.172])
	by postoffice.npac.syr.edu (8.9.3/8.9.3) with SMTP id PAA17625
	for <bkna@npac.syr.edu>; Fri, 3 Dec 1999 15:53:40 -0500 (EST)
From: "Tomasz Stachowiak" <stach@npac.syr.edu>
To: "Bo-kyun Na" <bkna@npac.syr.edu>
Subject: new version
Date: Fri, 3 Dec 1999 15:53:38 -0500
Message-ID: <NCBBJHPNAKHGJNLJFGHCAEDCCCAA.stach@npac.syr.edu>
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-Priority: 3 (Normal)
X-MSMail-Priority: Normal
X-Mailer: Microsoft Outlook IMO, Build 9.0.2416 (9.0.2910.0)
Importance: Normal
X-MimeOLE: Produced By Microsoft MimeOLE V5.00.2314.1300
Content-Type: text/plain;
	charset="iso-8859-2"
Content-Length: 2523

void ConvertYUVtoRGB32(unsigned char *src0,unsigned char *src1,unsigned char
*src2,
					 unsigned char *dst_ori,int width,int height)
{       
  extern long int crv_tab[];
  extern long int cbu_tab[];
  extern long int cgu_tab[];

  extern long int cgv_tab[];
  extern long int tab_76309[];

  int y11,y21;
int y12,y22;
  int y13,y23;
	int y14,y24;
  int u,v; 
  int i,j;
	int c11, c21, c31, c41;
	int c12, c22, c32, c42;
	unsigned int DW;
	unsigned int *id1, *id2;
  unsigned char *py1,*py2,*pu,*pv;
  unsigned char *d1, *d2;
  
  d1 = dst_ori;
  d1 += width*height*4 - width*4;
	d2 = d1 - width*4;
  
  py1 = src0; pu = src1; pv = src2;
	py2 = py1 + width;
 
	id1 = (unsigned int *)d1;
	id2 = (unsigned int *)d2;

  for (j = 0; j < height; j += 2) { 
    /* line j + 0 */
    for (i = 0; i < width; i += 4) {
      u = *pu++;
      v = *pv++;
      c11 = crv_tab[v];
      c21 = cgu_tab[u];
      c31 = cgv_tab[v];
      c41 = cbu_tab[u];
      u = *pu++;
      v = *pv++;
      c12 = crv_tab[v];
      c22 = cgu_tab[u];
      c32 = cgv_tab[v];
      c42 = cbu_tab[u];

      y11 = tab_76309[*py1++]; /* (255/219)*65536 */
      y12 = tab_76309[*py1++];
      y13 = tab_76309[*py1++]; /* (255/219)*65536 */
      y14 = tab_76309[*py1++];

      y21 = tab_76309[*py2++];
      y22 = tab_76309[*py2++];
      y23 = tab_76309[*py2++];
      y24 = tab_76309[*py2++];

      *d1++ = clp1[(y11 + c11)>>16];
      *d1++ = clp1[(y11 - c21 - c31)>>16];
      *d1++ = clp1[(y11 + c41)>>16];
	  *d1++ = 0;

      *d1++ = clp1[(y12 + c11)>>16];  
      *d1++ = clp1[(y12 - c21 - c31);
      *d1++ = clp1[(y12 + c41)>>16];
	  *d1++ = 0;

	  *d1++ = clp1[(y13 + c12)>>16];  
      *d1++ = clp1[(y13 - c22 - c32)>>16];
      *d1++ = clp1[(y13 + c42)>>16];
	  *d1++ = 0;

      *d1++ = clp1[(y14 + c12)>>16];  
      *d1++ = clp1[(y14 - c22 - c32)>>16];
	  *d1++ = clp1[(y14 + c42)>>16];
	  *d1++ = 0;

      *d2++ = clp1[(y21 + c11)>>16];
      *d2++ = clp1[(y21 - c21 - c31)>>16];
      *d2++ = clp1[(y21 + c41)>>16];
	  *d2++ = 0;

      *d2++ = clp1[(y22 + c11)>>16];  
      *d2++ = clp1[(y22 - c21 - c31);
      *d2++ = clp1[(y22 + c41)>>16];
	  *d2++ = 0;

	  *d2++ = clp1[(y23 + c12)>>16];  
      *d2++ = clp1[(y23 - c22 - c32)>>16];
      *d2++ = clp1[(y23 + c42)>>16];
	  *d2++ = 0;

      *d2++ = clp1[(y24 + c12)>>16];  
      *d2++ = clp1[(y24 - c22 - c32)>>16];
	  *d2++ = clp1[(y24 + c42)>>16];
	  *d2++ = 0;
	}

    d1 -= (12 * width);
    d2 -= (12 * width);
    py1 += width;
    py2 += width;
  }           
}  




